Index: issm/trunk/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 18301)
@@ -2803,618 +2741,4 @@
 
 }/*}}}*/
-void       Tria::Gradj(Vector<IssmDouble>* gradient,int control_type,int control_index){/*{{{*/
-	/*dJ/dalpha = ∂L/∂alpha = ∂J/∂alpha + ∂/∂alpha(KU-F)*/
-
-	int   approximation;
-	Seg*  seg=NULL;
-
-	/*If on water, grad = 0: */
-	if(!IsIceInElement()) return;
-
-	/*First deal with ∂/∂alpha(KU-F)*/
-	switch(control_type){
-		case FrictionCoefficientEnum:
-			inputs->GetInputValue(&approximation,ApproximationEnum);
-			switch(approximation){
-				case SSAApproximationEnum:
-					GradjDragSSA(gradient,control_index);
-					break;
-				case FSApproximationEnum:
-					GradjDragFS(gradient,control_index);
-					break;
-				case NoneApproximationEnum:
-					/*Gradient is 0*/
-					break;
-				default:
-					_error_("approximation " << EnumToStringx(approximation) << " not supported yet");
-			}
-			break;
-		case MaterialsRheologyBbarEnum:
-			GradjBSSA(gradient,control_index);
-			break;
-		case DamageDbarEnum:
-			GradjDSSA(gradient,control_index);
-			break;
-		case BalancethicknessThickeningRateEnum:
-			GradjDhDtBalancedthickness(gradient,control_index);
-			break;
-		case VxEnum:
-			GradjVxBalancedthickness(gradient,control_index);
-			break;
-		case VyEnum:
-			GradjVyBalancedthickness(gradient,control_index);
-			break;
-		case ThicknessEnum:
-			GradjThicknessBalancethicknessSoft(gradient,control_index);
-			break;
-		default:
-			_error_("control type not supported yet: " << control_type);
-	}
-
-	/*Now deal with ∂J/∂alpha*/
-	int        *responses = NULL;
-	int         num_responses,resp;
-	this->parameters->FindParam(&num_responses,InversionNumCostFunctionsEnum);
-	this->parameters->FindParam(&responses,NULL,InversionCostFunctionsEnum);
-
-	for(resp=0;resp<num_responses;resp++) switch(responses[resp]){
-		//FIXME: the control type should be checked somewhere (with respect to what variable are we taking the gradient!)
-
-		case ThicknessAbsMisfitEnum:
-		case ThicknessAbsGradientEnum:
-		case ThicknessAlongGradientEnum:
-		case ThicknessAcrossGradientEnum:
-		case BalancethicknessMisfitEnum:
-		case SurfaceAbsVelMisfitEnum:
-		case SurfaceRelVelMisfitEnum:
-		case SurfaceLogVelMisfitEnum:
-		case SurfaceLogVxVyMisfitEnum:
-		case SurfaceAverageVelMisfitEnum:
-			/*Nothing, J does not depends on the parameter being inverted for*/
-			break;
-		case DragCoefficientAbsGradientEnum:
-			inputs->GetInputValue(&approximation,ApproximationEnum);
-			switch(approximation){
-				case SSAApproximationEnum:
-					GradjDragGradient(gradient,control_index);
-					break;
-				case FSApproximationEnum:{
-					if(IsFloating() || !IsOnBase()) return;
-					int index1,index2;
-					this->EdgeOnBaseIndices(&index1,&index2);
-					Seg* seg = SpawnSeg(index1,index2);
-					seg->GradjDragGradient(gradient,control_index);
-					seg->DeleteMaterials(); delete seg;
-					break;
-												 }
-				case NoneApproximationEnum:
-					/*Gradient is 0*/
-					break;
-				default:
-					_error_("approximation " << EnumToStringx(approximation) << " not supported yet");
-			}
-			break;
-		case RheologyBbarAbsGradientEnum:
-			GradjBGradient(gradient,control_index);
-			break;
-		default:
-			_error_("response " << EnumToStringx(responses[resp]) << " not supported yet");
-	}
-
-	xDelete<int>(responses);
-}
-/*}}}*/
-void       Tria::GradjBGradient(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	int        i;
-	int        vertexpidlist[NUMVERTICES];
-	IssmDouble Jdet,weight;
-	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble dbasis[NDOF2][NUMVERTICES];
-	IssmDouble dk[NDOF2]; 
-	IssmDouble grade_g[NUMVERTICES]={0.0};
-	GaussTria  *gauss=NULL;
-
-	/*Retrieve all inputs we will be needing: */
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	GradientIndexing(&vertexpidlist[0],control_index);
-	Input* rheologyb_input=inputs->GetInput(MaterialsRheologyBbarEnum); _assert_(rheologyb_input);
-	Input* weights_input=inputs->GetInput(InversionCostFunctionsCoefficientsEnum);                _assert_(weights_input);
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussTria(2);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		GetJacobianDeterminant(&Jdet, &xyz_list[0][0],gauss);
-		GetNodalFunctionsDerivatives(&dbasis[0][0],&xyz_list[0][0],gauss);
-		weights_input->GetInputValue(&weight,gauss,RheologyBbarAbsGradientEnum);
-
-		/*Build alpha_complement_list: */
-		rheologyb_input->GetInputDerivativeValue(&dk[0],&xyz_list[0][0],gauss);
-
-		/*Build gradje_g_gaussian vector (actually -dJ/ddrag): */
-		for (i=0;i<NUMVERTICES;i++) grade_g[i]+=-weight*Jdet*gauss->weight*(dbasis[0][i]*dk[0]+dbasis[1][i]*dk[1]);
-	}
-	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
-
-	/*Clean up and return*/
-	delete gauss;
-}
-/*}}}*/
-void       Tria::GradjBSSA(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	/*Intermediaries*/
-	int        i;
-	int        doflist[NUMVERTICES];
-	IssmDouble vx,vy,lambda,mu,thickness,Jdet;
-	IssmDouble viscosity_complement;
-	IssmDouble dvx[NDOF2],dvy[NDOF2],dadjx[NDOF2],dadjy[NDOF2],dB[NDOF2]; 
-	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble basis[3],epsilon[3];
-	IssmDouble grad[NUMVERTICES]={0.0};
-	GaussTria *gauss = NULL;
-
-	/* Get node coordinates and dof list: */
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	GradientIndexing(&doflist[0],control_index);
-
-	/*Retrieve all inputs*/
-	Input* thickness_input=inputs->GetInput(ThicknessEnum);                     _assert_(thickness_input);
-	Input* vx_input=inputs->GetInput(VxEnum);                                   _assert_(vx_input);
-	Input* vy_input=inputs->GetInput(VyEnum);                                   _assert_(vy_input);
-	Input* adjointx_input=inputs->GetInput(AdjointxEnum);                       _assert_(adjointx_input);
-	Input* adjointy_input=inputs->GetInput(AdjointyEnum);                       _assert_(adjointy_input);
-	Input* rheologyb_input=inputs->GetInput(MaterialsRheologyBbarEnum); _assert_(rheologyb_input);
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussTria(4);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		thickness_input->GetInputValue(&thickness,gauss);
-		rheologyb_input->GetInputDerivativeValue(&dB[0],&xyz_list[0][0],gauss);
-		vx_input->GetInputDerivativeValue(&dvx[0],&xyz_list[0][0],gauss);
-		vy_input->GetInputDerivativeValue(&dvy[0],&xyz_list[0][0],gauss);
-		adjointx_input->GetInputDerivativeValue(&dadjx[0],&xyz_list[0][0],gauss);
-		adjointy_input->GetInputDerivativeValue(&dadjy[0],&xyz_list[0][0],gauss);
-
-		this->StrainRateSSA(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input);
-		material->GetViscosityComplement(&viscosity_complement,&epsilon[0]);
-
-		GetJacobianDeterminant(&Jdet, &xyz_list[0][0],gauss);
-		GetNodalFunctions(basis,gauss);
-
-		/*standard gradient dJ/dki*/
-		for (i=0;i<NUMVERTICES;i++) grad[i]+=-viscosity_complement*thickness*(
-					(2*dvx[0]+dvy[1])*2*dadjx[0]+(dvx[1]+dvy[0])*(dadjx[1]+dadjy[0])+(2*dvy[1]+dvx[0])*2*dadjy[1]
-					)*Jdet*gauss->weight*basis[i];
-	}
-
-	gradient->SetValues(NUMVERTICES,doflist,grad,ADD_VAL);
-
-	/*clean-up*/
-	delete gauss;
-}
-/*}}}*/
-void       Tria::GradjDSSA(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	/*Intermediaries*/
-	int        i;
-	int        doflist[NUMVERTICES];
-	IssmDouble vx,vy,lambda,mu,thickness,Jdet;
-	IssmDouble viscosity_complement;
-	IssmDouble dvx[NDOF2],dvy[NDOF2],dadjx[NDOF2],dadjy[NDOF2];
-	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble basis[3],epsilon[3];
-	IssmDouble grad[NUMVERTICES]={0.0};
-	GaussTria *gauss = NULL;
-
-	/* Get node coordinates and dof list: */
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	GradientIndexing(&doflist[0],control_index);
-
-	/*Retrieve all inputs*/
-	Input* thickness_input=inputs->GetInput(ThicknessEnum);                     _assert_(thickness_input);
-	Input* vx_input=inputs->GetInput(VxEnum);                                   _assert_(vx_input);
-	Input* vy_input=inputs->GetInput(VyEnum);                                   _assert_(vy_input);
-	Input* adjointx_input=inputs->GetInput(AdjointxEnum);                       _assert_(adjointx_input);
-	Input* adjointy_input=inputs->GetInput(AdjointyEnum);                       _assert_(adjointy_input);
-	if(this->material->IsDamage()){
-		Input* rheologyd_input=inputs->GetInput(DamageDbarEnum); _assert_(rheologyd_input);
-	}
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussTria(4);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		thickness_input->GetInputValue(&thickness,gauss);
-		vx_input->GetInputDerivativeValue(&dvx[0],&xyz_list[0][0],gauss);
-		vy_input->GetInputDerivativeValue(&dvy[0],&xyz_list[0][0],gauss);
-		adjointx_input->GetInputDerivativeValue(&dadjx[0],&xyz_list[0][0],gauss);
-		adjointy_input->GetInputDerivativeValue(&dadjy[0],&xyz_list[0][0],gauss);
-
-		this->StrainRateSSA(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input);
-		material->GetViscosityDComplement(&viscosity_complement,&epsilon[0]);
-
-		GetJacobianDeterminant(&Jdet, &xyz_list[0][0],gauss);
-		GetNodalFunctions(basis,gauss);
-
-		/*standard gradient dJ/dki*/
-		for (i=0;i<NUMVERTICES;i++) grad[i]+=-viscosity_complement*thickness*(
-					(2*dvx[0]+dvy[1])*2*dadjx[0]+(dvx[1]+dvy[0])*(dadjx[1]+dadjy[0])+(2*dvy[1]+dvx[0])*2*dadjy[1]
-					)*Jdet*gauss->weight*basis[i];
-	}
-
-	gradient->SetValues(NUMVERTICES,doflist,grad,ADD_VAL);
-
-	/*clean-up*/
-	delete gauss;
-}
-/*}}}*/
-void       Tria::GradjDragSSA(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	int        i;
-	int        analysis_type;
-	int        vertexpidlist[NUMVERTICES];
-	int        connectivity[NUMVERTICES];
-	IssmDouble vx,vy,lambda,mu,alpha_complement,Jdet;
-	IssmDouble bed,thickness,Neff,drag;
-	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble dk[NDOF2]; 
-	IssmDouble grade_g[NUMVERTICES]={0.0};
-	IssmDouble grade_g_gaussian[NUMVERTICES];
-	IssmDouble basis[3];
-	Friction*  friction=NULL;
-	GaussTria  *gauss=NULL;
-
-	if(IsFloating())return;
-
-	/*retrive parameters: */
-	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	GradientIndexing(&vertexpidlist[0],control_index);
-	this->GetVerticesConnectivityList(&connectivity[0]);
-
-	/*Build frictoin element, needed later: */
-	friction=new Friction(this,2);
-
-	/*Retrieve all inputs we will be needing: */
-	Input* adjointx_input=inputs->GetInput(AdjointxEnum);                   _assert_(adjointx_input);
-	Input* adjointy_input=inputs->GetInput(AdjointyEnum);                   _assert_(adjointy_input);
-	Input* vx_input=inputs->GetInput(VxEnum);                               _assert_(vx_input);
-	Input* vy_input=inputs->GetInput(VyEnum);                               _assert_(vy_input);
-	Input* dragcoefficient_input=inputs->GetInput(FrictionCoefficientEnum); _assert_(dragcoefficient_input);
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussTria(4);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		GetJacobianDeterminant(&Jdet, &xyz_list[0][0],gauss);
-		GetNodalFunctions(basis, gauss);
-
-		/*Build alpha_complement_list: */
-		friction->GetAlphaComplement(&alpha_complement,gauss);
-
-		dragcoefficient_input->GetInputValue(&drag, gauss);
-		adjointx_input->GetInputValue(&lambda, gauss);
-		adjointy_input->GetInputValue(&mu, gauss);
-		vx_input->GetInputValue(&vx,gauss);
-		vy_input->GetInputValue(&vy,gauss);
-		dragcoefficient_input->GetInputDerivativeValue(&dk[0],&xyz_list[0][0],gauss);
-
-		/*Build gradje_g_gaussian vector (actually -dJ/ddrag): */
-		for (i=0;i<NUMVERTICES;i++){
-			grade_g_gaussian[i]=-2*drag*alpha_complement*((lambda*vx+mu*vy))*Jdet*gauss->weight*basis[i];
-		}
-
-		/*Add gradje_g_gaussian vector to gradje_g: */
-		for(i=0;i<NUMVERTICES;i++){
-			_assert_(!xIsNan<IssmDouble>(grade_g[i]));
-			grade_g[i]+=grade_g_gaussian[i];
-		}
-	}
-	/*Analytical gradient*/
-	//delete gauss;
-	//gauss=new GaussTria();
-	//for (int iv=0;iv<NUMVERTICES;iv++){
-	//	gauss->GaussVertex(iv);
-	//	friction->GetAlphaComplement(&alpha_complement,gauss);
-	//	dragcoefficient_input->GetInputValue(&drag, gauss);
-	//	adjointx_input->GetInputValue(&lambda, gauss);
-	//	adjointy_input->GetInputValue(&mu, gauss);
-	//	vx_input->GetInputValue(&vx,gauss);
-	//	vy_input->GetInputValue(&vy,gauss);
-	//	grade_g[iv] = -2*1.e+7*drag*alpha_complement*(lambda*vx+mu*vy)/((IssmDouble)connectivity[iv]);
-	//}
-	/*End Analytical gradient*/
-
-	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
-
-	/*Clean up and return*/
-	delete gauss;
-	delete friction;
-}
-/*}}}*/
-void       Tria::GradjDragFS(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	/*Gradient is 0 if on shelf or not on bed*/
-	if(IsFloating() || !IsOnBase()) return;
-
-	int index1,index2;
-	this->EdgeOnBaseIndices(&index1,&index2);
-	Seg* seg = SpawnSeg(index1,index2);
-	seg->GradjDragFS(gradient,control_index);
-	seg->DeleteMaterials(); delete seg;
-}
-/*}}}*/
-void       Tria::GradjDragGradient(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	int        i;
-	int        vertexpidlist[NUMVERTICES];
-	IssmDouble Jdet,weight;
-	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble dbasis[NDOF2][NUMVERTICES];
-	IssmDouble dk[NDOF2]; 
-	IssmDouble grade_g[NUMVERTICES]={0.0};
-	GaussTria  *gauss=NULL;
-
-	/*Retrieve all inputs we will be needing: */
-	if(IsFloating())return;
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	GradientIndexing(&vertexpidlist[0],control_index);
-	Input* dragcoefficient_input=inputs->GetInput(FrictionCoefficientEnum); _assert_(dragcoefficient_input);
-	Input* weights_input=inputs->GetInput(InversionCostFunctionsCoefficientsEnum);                 _assert_(weights_input);
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussTria(2);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		GetJacobianDeterminant(&Jdet, &xyz_list[0][0],gauss);
-		GetNodalFunctionsDerivatives(&dbasis[0][0],&xyz_list[0][0],gauss);
-		weights_input->GetInputValue(&weight,gauss,DragCoefficientAbsGradientEnum);
-
-		/*Build alpha_complement_list: */
-		dragcoefficient_input->GetInputDerivativeValue(&dk[0],&xyz_list[0][0],gauss);
-
-		/*Build gradje_g_gaussian vector (actually -dJ/ddrag): */
-		for (i=0;i<NUMVERTICES;i++){
-			grade_g[i]+=-weight*Jdet*gauss->weight*(dbasis[0][i]*dk[0]+dbasis[1][i]*dk[1]);
-			_assert_(!xIsNan<IssmDouble>(grade_g[i]));
-		}
-	}
-	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
-
-	/*Clean up and return*/
-	delete gauss;
-}
-/*}}}*/
-void       Tria::GradjDhDtBalancedthickness(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	/*Intermediaries*/
-	int    vertexpidlist[NUMVERTICES];
-	IssmDouble lambda[NUMVERTICES];
-	IssmDouble gradient_g[NUMVERTICES];
-
-	/*Compute Gradient*/
-	GradientIndexing(&vertexpidlist[0],control_index);
-	GetInputListOnVertices(&lambda[0],AdjointEnum);
-	for(int i=0;i<NUMVERTICES;i++) gradient_g[i]=-lambda[i];
-
-	gradient->SetValues(NUMVERTICES,vertexpidlist,gradient_g,INS_VAL);
-}
-/*}}}*/
-void       Tria::GradjVxBalancedthickness(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	/*Intermediaries*/
-	int        i;
-	int        vertexpidlist[NUMVERTICES];
-	IssmDouble thickness,Jdet;
-	IssmDouble basis[3];
-	IssmDouble Dlambda[2],dp[2];
-	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble grade_g[NUMVERTICES] = {0.0};
-	GaussTria *gauss                = NULL;
-
-	/* Get node coordinates and dof list: */
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	GradientIndexing(&vertexpidlist[0],control_index);
-
-	/*Retrieve all inputs we will be needing: */
-	Input* adjoint_input=inputs->GetInput(AdjointEnum);     _assert_(adjoint_input);
-	Input* thickness_input=inputs->GetInput(ThicknessEnum); _assert_(thickness_input);
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussTria(2);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		GetJacobianDeterminant(&Jdet, &xyz_list[0][0],gauss);
-		GetNodalFunctions(basis, gauss);
-
-		adjoint_input->GetInputDerivativeValue(&Dlambda[0],&xyz_list[0][0],gauss);
-		thickness_input->GetInputValue(&thickness, gauss);
-		thickness_input->GetInputDerivativeValue(&dp[0],&xyz_list[0][0],gauss);
-
-		for(i=0;i<NUMVERTICES;i++) grade_g[i]+=thickness*Dlambda[0]*Jdet*gauss->weight*basis[i];
-	}
-
-	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
-
-	/*Clean up and return*/
-	delete gauss;
-}
-/*}}}*/
-void       Tria::GradjVyBalancedthickness(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	/*Intermediaries*/
-	int        i;
-	int        vertexpidlist[NUMVERTICES];
-	IssmDouble thickness,Jdet;
-	IssmDouble basis[3];
-	IssmDouble Dlambda[2],dp[2];
-	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble grade_g[NUMVERTICES] = {0.0};
-	GaussTria *gauss                = NULL;
-
-	/* Get node coordinates and dof list: */
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	GradientIndexing(&vertexpidlist[0],control_index);
-
-	/*Retrieve all inputs we will be needing: */
-	Input* adjoint_input=inputs->GetInput(AdjointEnum);     _assert_(adjoint_input);
-	Input* thickness_input=inputs->GetInput(ThicknessEnum); _assert_(thickness_input);
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussTria(2);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		GetJacobianDeterminant(&Jdet, &xyz_list[0][0],gauss);
-		GetNodalFunctions(basis, gauss);
-
-		adjoint_input->GetInputDerivativeValue(&Dlambda[0],&xyz_list[0][0],gauss);
-		thickness_input->GetInputValue(&thickness, gauss);
-		thickness_input->GetInputDerivativeValue(&dp[0],&xyz_list[0][0],gauss);
-
-		for(i=0;i<NUMVERTICES;i++) grade_g[i]+=thickness*Dlambda[1]*Jdet*gauss->weight*basis[i];
-	}
-	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
-
-	/*Clean up and return*/
-	delete gauss;
-}
-/*}}}*/
-void       Tria::GradjThicknessBalancethicknessSoft(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	/*Intermediaries */
-	int         i,resp;
-	int         vertexpidlist[NUMVERTICES];
-	IssmDouble  Jdet;
-	IssmDouble  thickness,thicknessobs,weight;
-	int         num_responses;
-	IssmDouble  xyz_list[NUMVERTICES][3];
-	IssmDouble  basis[3];
-	IssmDouble  dbasis[NDOF2][NUMVERTICES];
-	IssmDouble  dH[2];
-	IssmDouble  vx,vy,vel;
-	IssmDouble  dvx[2],dvy[2];
-	IssmDouble dhdt,basal_melting,surface_mass_balance;
-	GaussTria *gauss     = NULL;
-	int       *responses = NULL;
-	IssmDouble grade_g[NUMVERTICES] = {0.0};
-
-	/* Get node coordinates and dof list: */
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	GradientIndexing(&vertexpidlist[0],control_index);
-
-	/*Retrieve all inputs and parameters*/
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	this->parameters->FindParam(&num_responses,InversionNumCostFunctionsEnum);
-	this->parameters->FindParam(&responses,NULL,InversionCostFunctionsEnum);
-	Input* thickness_input            = inputs->GetInput(ThicknessEnum);                          _assert_(thickness_input);
-	Input* thicknessobs_input         = inputs->GetInput(InversionThicknessObsEnum);              _assert_(thicknessobs_input);
-	Input* weights_input              = inputs->GetInput(InversionCostFunctionsCoefficientsEnum); _assert_(weights_input);
-	Input* vx_input                   = inputs->GetInput(VxEnum);                                 _assert_(vx_input);
-	Input* vy_input                   = inputs->GetInput(VyEnum);                                 _assert_(vy_input);
-	Input* surface_mass_balance_input = inputs->GetInput(SurfaceforcingsMassBalanceEnum);         _assert_(surface_mass_balance_input);
-	Input* basal_melting_input        = inputs->GetInput(BasalforcingsMeltingRateEnum);           _assert_(basal_melting_input);
-	Input* dhdt_input                 = inputs->GetInput(BalancethicknessThickeningRateEnum);     _assert_(dhdt_input);
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussTria(2);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		GetJacobianDeterminant(&Jdet, &xyz_list[0][0],gauss);
-		GetNodalFunctions(basis, gauss);
-		GetNodalFunctionsDerivatives(&dbasis[0][0],&xyz_list[0][0],gauss);
-
-		thickness_input->GetInputValue(&thickness, gauss);
-		thickness_input->GetInputDerivativeValue(&dH[0],&xyz_list[0][0],gauss);
-		thicknessobs_input->GetInputValue(&thicknessobs, gauss);
-
-		/*Loop over all requested responses*/
-		for(resp=0;resp<num_responses;resp++){
-
-			weights_input->GetInputValue(&weight,gauss,responses[resp]);
-
-			switch(responses[resp]){
-
-				case ThicknessAbsMisfitEnum:
-					for(i=0;i<NUMVERTICES;i++) grade_g[i]+= (thicknessobs-thickness)*weight*Jdet*gauss->weight*basis[i];
-					break;
-				case ThicknessAbsGradientEnum:
-					for(i=0;i<NUMVERTICES;i++) grade_g[i]+= - weight*dH[0]*dbasis[0][i]*Jdet*gauss->weight;
-					for(i=0;i<NUMVERTICES;i++) grade_g[i]+= - weight*dH[1]*dbasis[1][i]*Jdet*gauss->weight;
-					break;
-				case ThicknessAlongGradientEnum:
-					vx_input->GetInputValue(&vx,gauss);
-					vy_input->GetInputValue(&vy,gauss);
-					vel = sqrt(vx*vx+vy*vy);
-					vx  = vx/(vel+1.e-9);
-					vy  = vy/(vel+1.e-9);
-					for(i=0;i<NUMVERTICES;i++) grade_g[i]+= - weight*(dH[0]*vx+dH[1]*vy)*(dbasis[0][i]*vx+dbasis[1][i]*vy)*Jdet*gauss->weight;
-					break;
-				case ThicknessAcrossGradientEnum:
-					vx_input->GetInputValue(&vx,gauss);
-					vy_input->GetInputValue(&vy,gauss);
-					vel = sqrt(vx*vx+vy*vy);
-					vx  = vx/(vel+1.e-9);
-					vy  = vy/(vel+1.e-9);
-					for(i=0;i<NUMVERTICES;i++) grade_g[i]+= - weight*(dH[0]*(-vy)+dH[1]*vx)*(dbasis[0][i]*(-vy)+dbasis[1][i]*vx)*Jdet*gauss->weight;
-					break;
-				case BalancethicknessMisfitEnum:
-					surface_mass_balance_input->GetInputValue(&surface_mass_balance,gauss);
-					basal_melting_input->GetInputValue(&basal_melting,gauss);
-					dhdt_input->GetInputValue(&dhdt,gauss);
-					vx_input->GetInputValue(&vx,gauss);
-					vx_input->GetInputDerivativeValue(&dvx[0],&xyz_list[0][0],gauss);
-					vy_input->GetInputValue(&vy,gauss);
-					vy_input->GetInputDerivativeValue(&dvy[0],&xyz_list[0][0],gauss);
-					for(i=0;i<NUMVERTICES;i++){
-						grade_g[i]+= - weight*Jdet*gauss->weight*(
-									(vx*dH[0]+vy*dH[1] + thickness*(dvx[0]+dvy[1]))*(vx*dbasis[0][i]+ vy*dbasis[1][i] + basis[i]*(dvx[0]+dvy[1]))
-									-(surface_mass_balance-basal_melting-dhdt)*(vx*dbasis[0][i]+ vy*dbasis[1][i] + basis[i]*(dvx[0]+dvy[1]))
-									);
-					}
-					break;
-				default:
-					_error_("response " << EnumToStringx(responses[resp]) << " not supported yet");
-			}
-		}
-	}
-
-	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
-
-	/*Clean up and return*/
-	delete gauss;
-	xDelete<int>(responses);
-}
-/*}}}*/
-void       Tria::GradientIndexing(int* indexing,int control_index){/*{{{*/
-
-	/*Get some parameters*/
-	int num_controls;
-	parameters->FindParam(&num_controls,InversionNumControlParametersEnum);
-
-	/*get gradient indices*/
-	for(int i=0;i<NUMVERTICES;i++){
-		indexing[i]=num_controls*this->vertices[i]->Pid() + control_index;
-	}
-
-}
-/*}}}*/
 void       Tria::GetVectorFromControlInputs(Vector<IssmDouble>* vector,int control_enum,int control_index,const char* data){/*{{{*/
 
@@ -3442,7 +2766,23 @@
 
 	IssmDouble  values[NUMVERTICES];
-	int     vertexpidlist[NUMVERTICES];
-	Input  *input     = NULL;
-	Input  *new_input = NULL;
+	int         vertexpidlist[NUMVERTICES],control_init;
+
+
+	/*Get Domain type*/
+	int domaintype;
+	parameters->FindParam(&domaintype,DomainTypeEnum);
+
+	/*Specific case for depth averaged quantities*/
+	control_init=control_enum;
+	if(domaintype==Domain2DverticalEnum){
+		if(control_enum==MaterialsRheologyBbarEnum){
+			control_enum=MaterialsRheologyBEnum;
+			if(!IsOnBase()) return;
+		}
+		if(control_enum==DamageDbarEnum){
+			control_enum=DamageDEnum;
+			if(!IsOnBase()) return;
+		}
+	}
 
 	/*Get out if this is not an element input*/
@@ -3453,11 +2793,10 @@
 
 	/*Get values on vertices*/
-	for (int i=0;i<NUMVERTICES;i++){
+	for(int i=0;i<NUMVERTICES;i++){
 		values[i]=vector[vertexpidlist[i]];
 	}
-	new_input = new TriaInput(control_enum,values,P1Enum);
-
-	input=(Input*)this->inputs->GetInput(control_enum);   _assert_(input);
-	if (input->ObjectEnum()!=ControlInputEnum){
+	Input* new_input = new TriaInput(control_enum,values,P1Enum);
+	Input* input     = (Input*)this->inputs->GetInput(control_enum);   _assert_(input);
+	if(input->ObjectEnum()!=ControlInputEnum){
 		_error_("input " << EnumToStringx(control_enum) << " is not a ControlInput");
 	}
@@ -3472,5 +2811,5 @@
 
 	/*Fetch number of nodes for this finite element*/
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(this->element_type);
 
 	/*Fetch dof list and allocate solution vector*/
@@ -3634,8 +2973,6 @@
 
 	int        i,migration_style;
-	bool       oldfloating;
-	bool       floatingelement = false;
 	bool       groundedelement = false;
-	IssmDouble bed_hydro,yts,gl_melting_rate;
+	IssmDouble bed_hydro,yts;
 	IssmDouble rho_water,rho_ice,density;
 	IssmDouble melting[NUMVERTICES],phi[NUMVERTICES];;
@@ -3644,5 +2981,4 @@
 	/*Recover info at the vertices: */
 	parameters->FindParam(&migration_style,GroundinglineMigrationEnum);
-	parameters->FindParam(&gl_melting_rate,GroundinglineMeltingRateEnum);
 	parameters->FindParam(&yts,ConstantsYtsEnum);
 	GetInputListOnVertices(&h[0],ThicknessEnum);
@@ -3654,5 +2990,4 @@
 	rho_ice     = matpar->GetRhoIce();
 	density     = rho_ice/rho_water;
-	oldfloating = this->IsFloating(); //figure out if element is floating before we start to change everything
 
 	if(migration_style == ContactEnum){
@@ -3667,16 +3002,4 @@
 			}
 		}
-
-		/*Add basal melting rate if element just ungrounded*/
-		for(i=0;i<NUMVERTICES;i++){
-			if(phi[i]<0.){
-				floatingelement=true;
-				break;
-			}
-		}
-		if(!oldfloating && floatingelement==true){
-			for(i=0;i<NUMVERTICES;i++) melting[i]=gl_melting_rate/yts;
-			this->inputs->AddInput(new TriaInput(BasalforcingsMeltingRateEnum,&melting[0],P1Enum));
-		} 
 
 		/*Update inputs*/
@@ -3729,30 +3052,4 @@
 	this->inputs->AddInput(new TriaInput(MaskGroundediceLevelsetEnum,&phi[0],P1Enum));
 
-	/*SubelementMigrationEnum: if one grounded, all grounded*/
-	if(migration_style==SubelementMigrationEnum || migration_style==SubelementMigration2Enum){
-		for(i=0;i<NUMVERTICES;i++){
-			if(phi[i]>0.){
-				groundedelement=true;
-				break;
-			}
-		}
-		floatingelement=!groundedelement;
-	}
-	else{
-		/*Otherwise: if one floating, all floating*/
-		for(i=0;i<NUMVERTICES;i++){
-			if(phi[i]<=0.){
-				floatingelement=true;
-				break;
-			}
-		}
-	}
-
-	/*Add basal melting rate if element just ungrounded*/
-	if(!oldfloating && floatingelement==true){
-		for(i=0;i<NUMVERTICES;i++)melting[i]=gl_melting_rate/yts;
-		this->inputs->AddInput(new TriaInput(BasalforcingsMeltingRateEnum,&melting[0],P1Enum));
-	} 
-
 	/*Update inputs*/
 	this->inputs->AddInput(new TriaInput(SurfaceEnum,&s[0],P1Enum));
